/*
* This file is part of ArmarX.
*
* ArmarX is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2 of
* the License, or (at your option) any later version.
*
* ArmarX is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*
* @package    ArmarX::
* @author     Nikolaus Vahrenkamp ( vahrenkamp at kit dot edu)
* @date       2012
* @copyright  http://www.gnu.org/licenses/gpl.txt
*             GNU General Public License
*/

#include "MMMPlayerConfigDialog.h"
#include "ui_MMMPlayerConfigDialog.h"
//#include <IceUtil/UUID.h>

armarx::MMMPlayerConfigDialog::MMMPlayerConfigDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::MMMPlayerConfigDialog)
{
    ui->setupUi(this);
    fileDialog = new QFileDialog(parent);
    fileDialog->setModal(true);
    fileDialog->setFileMode(QFileDialog::ExistingFiles);
    QStringList fileTypes;
    fileTypes << tr("XML (*.xml)")<< tr("All Files (*.*)");
    fileDialog->setNameFilters(fileTypes);

    connect(ui->btnSelectConfigFile, SIGNAL(clicked()), fileDialog, SLOT(show()));
    connect(fileDialog, SIGNAL(accepted()), this, SLOT(configFileSelected()));
    connect(ui->buttonBox, SIGNAL(accepted()), this, SLOT(on_buttonBox_accepted()));
}

armarx::MMMPlayerConfigDialog::~MMMPlayerConfigDialog()
{
    delete ui;
}

void armarx::MMMPlayerConfigDialog::on_buttonBox_accepted()
{
    this->accept();
}

void armarx::MMMPlayerConfigDialog::on_buttonBox_rejected()
{
    this->reject();
}

void armarx::MMMPlayerConfigDialog::configFileSelected()
{
    ui->editConfigFile->setText(this->fileDialog->selectedFiles()[0]);
}
