/*
* This file is part of ArmarX.
*
* ArmarX is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* ArmarX is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*
* @package    RobotComponents
* @author     Patrick Grube
* @copyright  2015
* @license    http://www.gnu.org/licenses/gpl.txt
*             GNU General Public License
*/

#ifndef _ARMARX_ROBOTCOMPONENTS_UNITS_MMMPLAYERINTERFACE_SLICE_
#define _ARMARX_ROBOTCOMPONENTS_UNITS_MMMPLAYERINTERFACE_SLICE_

#include <RobotAPI/interface/units/UnitInterface.ice>
#include <RobotAPI/interface/units/KinematicUnitInterface.ice>

module armarx
{
    interface MMMPlayerInterface extends KinematicUnitListener
    {
        bool startMMMPlayer();
        bool pauseMMMPlayer();
        bool stopMMMPlayer();
        int loadTrajectory(string filename, string projects); //returns # of frames
        int getCurrentFrame();
        string getMotionPath();
        StringList getJointNames();
        void setCurrentFrame(int frame);
        bool setLoopPlayback(bool loop);
        bool setUsePID(bool usePID);
        void setFPS(int FPS);
//        void setJointsInUse(StringBoolMap useJoints);
    };
};

#endif
